main()
{
	//maps\mp\mp_blocks_fx::main();
	//maps\createart\mp_blocks_art::main();
	maps\mp\_load::main();	
	
	maps\mp\_compass::setupMiniMap("compass_map_mp_blocks");

	//setExpFog(500, 2200, 0.81, 0.75, 0.63, 0);
	//VisionSetNaked( "mp_blocks" );
	ambientPlay("ambient_test_block_ext");

	game["allies"] = "sas";
	game["axis"] = "opfor";
	game["attackers"] = "axis";
	game["defenders"] = "allies";
	game["allies_soldiertype"] = "woodland";
	game["axis_soldiertype"] = "woodland";

	setdvar( "r_specularcolorscale", "1" );
	setdvar("r_glowbloomintensity0",".25");
	setdvar("r_glowbloomintensity1",".25");
	setdvar("r_glowskybleedintensity0",".3");
	setdvar("compassmaxrange","1800");

	level.groundheight = -32;
	level.reset = false;
	level.player_height = 72;
	level.player_width = 30;

	//fx
	level.fx_wood_explosion = loadfx("explosions/wood_explosion");
	level.fx_fairydust = loadfx("props/fairydust");

	//block code
	level.trig_block_tower = getentarray("trig_block_tower","targetname");
	level.block_tower_height = 240;
	level.block_tower_width = 96;
	for(i=0;i<level.trig_block_tower.size;i++)
	{
		level.trig_block_tower[i].block_max = 17;
		level.trig_block_tower[i].enabled = true;
		level.trig_block_tower[i].block[0] = getent(level.trig_block_tower[i].target, "targetname");
		for(j=1;j<level.trig_block_tower[i].block_max;j++)
		{
			level.trig_block_tower[i].block[j] = getent(level.trig_block_tower[i].block[j-1].target, "targetname");
		}
		level.trig_block_tower[i].block_origin[0] = getent(level.trig_block_tower[i].block[level.trig_block_tower[i].block_max - 1].target, "targetname");
		for(j=1;j<level.trig_block_tower[i].block_max;j++)
		{
			level.trig_block_tower[i].block_origin[j] = getent(level.trig_block_tower[i].block_origin[j-1].target, "targetname");
		}
		for(j=0;j<level.trig_block_tower[i].block_max;j++)
		{
			level.trig_block_tower[i].block[j] moveto(level.trig_block_tower[i].block_origin[j].origin, 0.01);
		}
		wait(0.01);
		level.trig_block_tower[i] thread block_tower();
	}


	level.trig_block_letter = getentarray("trig_block_letter","targetname");
	for(i=0;i<level.trig_block_letter.size;i++)
	{
		level.trig_block_letter[i].block = getent(level.trig_block_letter[i].target, "targetname");
		level.trig_block_letter[i].block moveto(level.trig_block_letter[i].origin, 0.01);
	}
	level.trig_block_letter[0].block waittill("movedone");
	for(i=0;i<level.trig_block_letter.size;i++)
	{
		level.trig_block_letter[i].enabled = true;
		//flips block on side if percent_ud is too high; problem: too choppy
		//level.trig_block_letter[i].rotate_1 = spawn ("script_model",level.trig_block_letter[i].block.origin);
		//level.trig_block_letter[i].rotate_2 = spawn ("script_model",level.trig_block_letter[i].block.origin);
		//level.trig_block_letter[i].yaw_angle = 0;
		level.trig_block_letter[i] EnableLinkTo();
		level.trig_block_letter[i] linkto (level.trig_block_letter[i].block);
		level.trig_block_letter[i].block_grenade = false;
		if (isdefined(level.trig_block_letter[i].script_noteworthy))
		{
			if (level.trig_block_letter[i].script_noteworthy == "grenade")
			{
				level.trig_block_letter[i].block_grenade = true;
				level.trig_block_letter[i].trig_grenade = getent(level.trig_block_letter[i].block.target, "targetname");
				level.trig_block_letter[i].trig_grenade thread give_grenade();
				level.trig_block_letter[i].trig_grenade EnableLinkTo();
				level.trig_block_letter[i].trig_grenade linkto (level.trig_block_letter[i].block);
			}
		}
		level.trig_block_letter[i].starting_origin = level.trig_block_letter[i].origin;
		level.trig_block_letter[i].shot = false;
		level.trig_block_letter[i].shot_count = 0;
		level.trig_block_letter[i].shot_count_max = 3;
		level.trig_block_letter[i].radius = 18;
		level.trig_block_letter[i].height = 36;
		level.trig_block_letter[i].shot_distance = 64;
		level.trig_block_letter[i].blockontop_max = 4;
		level.trig_block_letter[i].index = i;
		level.trig_block_letter[i].moving = false;
		for(j=0;j<level.trig_block_letter[i].blockontop_max;j++)
		{
			level.trig_block_letter[i].blockontop[j] = -1;
		}
	}
	for(i=0;i<level.trig_block_letter.size;i++)
	{
		level.trig_block_letter[i].blockontop_index = 0;
		for(j=0;j<level.trig_block_letter.size;j++)
		{
			if((abs(get_x(level.trig_block_letter[j].origin - level.trig_block_letter[i].origin)) < level.trig_block_letter[i].height) && (abs(get_y(level.trig_block_letter[j].origin - level.trig_block_letter[i].origin)) < level.trig_block_letter[i].height) && (int(get_z(level.trig_block_letter[j].origin - level.trig_block_letter[i].origin) + 0.1) == level.trig_block_letter[i].height))
			{
				level.trig_block_letter[i].blockontop[level.trig_block_letter[i].blockontop_index] = j;
				if (level.trig_block_letter[i].blockontop_index < level.trig_block_letter[i].blockontop_max - 1)
				{
					level.trig_block_letter[i].blockontop_index++;
				}
			}
		}
	}
	for(i=0;i<level.trig_block_letter.size;i++)
	{
		level.trig_block_letter[i] thread block_physics();
	}
	level thread block_reset();
}

//reset blocks
block_reset()
{
	while (1)
	{
		for(i=0;i<level.trig_block_letter.size;i++)
		{
			if (level.trig_block_letter[i].block.origin != level.trig_block_letter[i].starting_origin)
			{
				level.reset = true;
			}
		}
		for(i=0;i<level.trig_block_tower.size;i++)
		{
			if (level.trig_block_tower[i].enabled == false)
			{
				level.reset = true;
			}
		}
		if (level.reset)
		{
			players = getentarray("player", "classname");
			for (i=0;i<players.size;i++)
			{   
				player = players[i];
			}
			level.trig_block_letter[0] playsound("magic");
			for(i=0;i<level.trig_block_letter.size;i++)
			{
				level.trig_block_letter[i].block show();
				level.trig_block_letter[i].enabled = true;
				level.trig_block_letter[i].shot = false;
				level.trig_block_letter[i].shot_count = 0;
				level.trig_block_letter[i].shot_count_max = 3;
				if (level.trig_block_letter[i].block.origin != level.trig_block_letter[i].starting_origin)
				{
					level.trig_block_letter[i].block notsolid();
					level.trig_block_letter[i].moving = true;
					level.trig_block_letter[i].block moveto(level.trig_block_letter[i].starting_origin, 0.1, 0, 0);
					level.trig_block_letter[i].block rotateto((0, 0, 0), 0.1);
					PlayFX(level.fx_fairydust, level.trig_block_letter[i].starting_origin);
				}
			}
			for(i=0;i<level.trig_block_tower.size;i++)
			{
				for(j=0;j<level.trig_block_tower[i].block_max;j++)
				{
					level.trig_block_tower[i].block[j] show();
				}
				if (level.trig_block_tower[i].enabled == false)
				{
					for(j=0;j<level.trig_block_tower[i].block_max;j++)
					{
						level.trig_block_tower[i].block[j] moveto(level.trig_block_tower[i].block_origin[j].origin, 0.1);
						level.trig_block_tower[i].block[j] rotateto((0, 0, 0), 0.1);
						PlayFX(level.fx_fairydust, level.trig_block_tower[i].block_origin[j].origin);
					}
				}
			}
			wait(0.2);
			for(i=0;i<level.trig_block_tower.size;i++)
			{
				for(j=0;j<level.trig_block_tower[i].block_max;j++)
				{
					level.trig_block_tower[i].block[j] solid();
				}
				for(j=0;j<players.size;j++)
				{   
					if ((player_block_tower_collision(players[j], level.trig_block_tower[i])) && (!level.trig_block_tower[i].enabled))
					{
						players[j] setorigin(players[j].origin + (0, 0, level.block_tower_height + 4));
					}
				}
				level.trig_block_tower[i].enabled = true;
			}
			for(i=0;i<level.trig_block_letter[0].blockontop_max;i++)
			{
				for(j=0;j<level.trig_block_letter.size;j++)
				{
					if (level.trig_block_letter[j].moving)
					{
						for(k=0;k<players.size;k++)
						{
							if (player_block_letter_collision(players[k], level.trig_block_letter[j]))
							{
								players[k] setorigin(players[k].origin + (0, 0, level.trig_block_letter[j].height + 4));
							}
						}
					}
				}
			}			
			for(i=0;i<level.trig_block_letter.size;i++)
			{
				level.trig_block_letter[i].moving = false;
				level.trig_block_letter[i].block solid();
			}
		}
		level.reset = false;
		wait(180);
	}
}


//give grenade
give_grenade()
{
	while (1)
	{
		self waittill("trigger", user);
		if (isdefined(user))
		{
			if (user GetWeaponAmmoClip("frag_grenade_mp") < 4)
			{
				self playsound("givegrenade");
				user givemaxammo("frag_grenade_mp");
			}
		}
		wait(0.01);
	}
}

//block tower
block_tower()
{
	while (1)
	{
		self waittill("damage", dmg, user, dir, point, mod);
		if (self.enabled && isdefined(dmg) && isdefined(user) && isdefined(dir) && isdefined(point) && isdefined(mod))
		{
			if (dmg >= 200)
			{
				self.enabled = false;
				for(i=0;i<self.block_max;i++)
				{
					self.block[i] notsolid();
					self.block[i] moveto(self.block[i].origin + (self.block[i].origin - self.origin) / length(self.block[i].origin - self.origin) * 1000, 1, 0, 0);
					self.block[i] rotateto(self.block[i].angles + (180, 180, 180), 1);
				}
				self.block[0] waittill("movedone");
				for(i=0;i<self.block_max;i++)
				{
					self.block[i] hide();
					PlayFX(level.fx_wood_explosion, self.block[i].origin);
				}
			}
		}
		wait(0.01);
	}
}

//block physics
block_physics()
{
	while (1)
	{
		self waittill("damage", dmg, user, dir, point, mod);
		if (self.enabled && isdefined(dmg) && isdefined(user) && isdefined(user.origin) && isdefined(dir) && isdefined(point) && isdefined(mod))
		{
			if (!self.shot && (mod != "MOD_MELEE"))
			{
				self.shot = true;
				if (((int(get_z(user.origin - self.block.origin)) == self.height / 2) && (abs(get_x(user.origin - self.block.origin)) < 33)) && (abs(get_y(user.origin - self.block.origin)) < 33))
				{
					userontop = true;
				}
				else
				{
					userontop = false;
				}
				if (userontop && ((dmg > 10) && !self.block_grenade))
				{
					self.shot_count++;
				}
				else if (userontop && self.block_grenade)
				{
					self.shot_count = 1;
				}
				if ((!userontop && (self.shot_count < self.shot_count_max - 1)  && ((mod == "MOD_PISTOL_BULLET") || (mod == "MOD_RIFLE_BULLET"))) || ((dmg > 50) && self.block_grenade))
				{
					self thread block_jump(dmg, user, dir, point, mod, 25);
				}
				else if ((self.shot_count == self.shot_count_max - 1) || ((dmg > 50) && !self.block_grenade))
				{
					self.enabled = false;
					self thread block_explode(dmg, user, dir, point, mod);
				}
				else
				{
					self.shot = false;
				}
			}
		}
		wait(0.01);
	}
}

block_explode(dmg, user, dir, point, mod)
{
	if (isdefined(dmg) && isdefined(user) && isdefined(user.origin) && isdefined(dir) && isdefined(point) && isdefined(mod))
	{
		if (dir == (0, 0, 0))
		{
			if (length(self.origin - user.origin) == 0)
			{
				dir = (1, 0, 0);
			}
			else
			{
				dir = (self.origin - user.origin) / length(self.origin - user.origin);
			}
		}
		else
		{
			dir = dir / length(dir);
		}
		if (self.shot_count == 0)
		{
			for(i=0;i<self.blockontop_max;i++)
			{
				if(self.blockontop[i] != -1)
				{
					if((level.trig_block_letter[self.blockontop[i]].shot_count == 0) && !level.trig_block_letter[self.blockontop[i]].shot)
					{
						level.trig_block_letter[self.blockontop[i]].shot = true;
						level.trig_block_letter[self.blockontop[i]] thread block_jump(dmg, user, dir, point, mod, 25);
					}
				}
			}
		}	
		if (!self.block_grenade)
		{
			self.shot_count++;
		}
		else
		{
			self.shot_count = 1;
		}
		self.block notsolid();
		if (dmg > 50)
		{
			self.block moveto(self.block.origin + dir * 1000, 1, 0, 0);
			self.block rotateto(self.block.angles + (180, 180, 180), 1);
			self.block waittill("movedone");
			self.shot = false;
		}
		if (!level.reset)
		{
			self.block hide();
			PlayFX(level.fx_wood_explosion, self.block.origin);
		}
	}
}

block_jump(dmg, user, dir, point, mod, v)
{
	if (self.enabled && isdefined(dmg) && isdefined(user) && isdefined(user.origin) && isdefined(dir) && isdefined(point) && isdefined(mod) && isdefined(v))
	{
		if (dir == (0, 0, 0))
		{
			if (length(self.origin - user.origin) == 0)
			{
				dir = (1, 0, 0);
			}
			else
			{
				dir = (self.origin - user.origin) / length(self.origin - user.origin);
			}
		}
		else
		{
			dir = dir / length(dir);
		}
		if (self.shot_count == 0)
		{
			for(i=0;i<self.blockontop_max;i++)
			{
				if(self.blockontop[i] != -1)
				{
					if((level.trig_block_letter[self.blockontop[i]].shot_count == 0) && !level.trig_block_letter[self.blockontop[i]].shot)
					{
						level.trig_block_letter[self.blockontop[i]].shot = true;
						level.trig_block_letter[self.blockontop[i]] thread block_jump(dmg, user, dir, point, mod, v * 4 /5);
					}
				}
			}
		}
		if (!self.block_grenade)
		{
			self.shot_count++;
		}
		else
		{
			self.shot_count = 1;
		}
		if (user getstance() == "crouch")
		{
			userzfix = 6;
		}
		else if (user getstance() == "prone")
		{
			userzfix = -24;
		}
		else
		{
			userzfix = 24;
		}
		//angle vectors: (up/down angle, left/right angle, 0)
		gun_angle = vectortoangles(dir);
		gun_angle_ud = 360 - get_pos_angle(get_x(gun_angle));
		gun_angle_lr = get_pos_angle(get_y(gun_angle));
		obj_angle = vectortoangles(self.block.origin - user.origin + (0, 0, userzfix));
		obj_angle_ud = get_pos_angle(get_x(obj_angle));
		obj_angle_lr = get_pos_angle(get_y(obj_angle));
		distance = distance(self.block.origin, user.origin);
		distance_x = get_x(self.block.origin - user.origin);
		distance_y = get_y(self.block.origin - user.origin);
		angle_max = atan(self.radius / distance);
		angle_ud = get_angle_difference(obj_angle_ud, gun_angle_ud);
		angle_lr = get_angle_difference(obj_angle_lr, gun_angle_lr);
		percent_ud = get_percent_clip(angle_ud, angle_max);
		percent_lr = get_percent_clip(angle_lr, angle_max);
		//parabola follows y = bx - ax^2, where y is height and x is shot_distance
		time_ratio = 0.05;
		angle_lr_max = 45;
		if (gun_angle_ud > 180)
		{
			angle = 360 - gun_angle_ud;
		}
		else
		{
			angle = abs(gun_angle_ud);
		}
		a = 9.8 / (2 * v * v * cos(abs(angle)) * cos(abs(angle)));
		if (abs(angle) >= 90)
		{
			angle = 0;
		}
		b = tan(abs(angle));
		if (b == 0)
		{
			b = 0.001;
		}
		c = level.groundheight - (get_z(self.block.origin) - self.height /  2);
		if (a == 0)
		{
			a = 0.001;
		}
		shot_distance = (b + sqrt(abs(b * b - 4 * a * c))) / (2 * a);
		shot_distance_start_to_max = b / (2 * a);
		shot_distance_max_to_finish = shot_distance - shot_distance_start_to_max;
		shot_distance_x = get_x(dir) * shot_distance;
		shot_distance_y = get_y(dir) * shot_distance;
		shot_distance_start_to_max_x = get_x(dir) * shot_distance_start_to_max;
		shot_distance_start_to_max_y = get_y(dir) * shot_distance_start_to_max;
		shot_distance_max_to_finish_x = get_x(dir) * shot_distance_max_to_finish;
		shot_distance_max_to_finish_y = get_y(dir) * shot_distance_max_to_finish;

		//flips block on side if percent_ud is too high; problem: too choppy, and needs clip when on side
		//block_flip = int(get_pos_angle(get_y(gun_angle) - self.yaw_angle + 45) / 90);
		//self.rotate_1 moveto(self.block.origin, 0.001);
		//self.rotate_2 moveto(self.block.origin, 0.001);
		//self.rotate_1 waittill("movedone");
		//self.rotate_1 rotateto((0, self.yaw_angle + block_flip * 90, 0), 0.001);
		//self.rotate_2 rotateto(self.block.angles, 0.001);
		//self.rotate_1 waittill("rotatedone");
		//self.rotate_2 linkto (self.rotate_1);
		//if (percent_ud < -50)
		//{
		//	self.rotate_1 rotatepitch(90, 0.001);
		//	self.rotate_1 waittill("rotatedone");
		//}
		//self.rotate_1 rotateyaw(percent_lr * angle_lr_max / 100, 0.001);
		//self.rotate_1 waittill("rotatedone");
		//self.yaw_angle = self.yaw_angle + percent_lr * angle_lr_max / 100;
		//self.rotate_2 unlink();
		//self.block rotateto(self.rotate_2.angles, time_ratio * shot_distance / v);

		if(!self.moving)
		{
			self.moving = true;
			if(shot_distance_start_to_max > 1 && shot_distance_max_to_finish > 1)
			{
				if (time_ratio * shot_distance / v > 0)
				{
					self.block rotateyaw(percent_lr * angle_lr_max / 100, time_ratio * shot_distance / v);
				}
				if (time_ratio * shot_distance_start_to_max / v > 0)
				{
					self.block moveto(self.block.origin + (shot_distance_start_to_max_x, shot_distance_start_to_max_y, b * b / (4 * a)), time_ratio * shot_distance_start_to_max / v, 0, time_ratio * shot_distance_start_to_max / v);
					self.block waittill("movedone");
				}
				if (time_ratio * shot_distance_max_to_finish / v > 0)
				{
					self.block moveto(self.block.origin + (shot_distance_max_to_finish_x, shot_distance_max_to_finish_y, -1 * b * b / (4 * a) + c), time_ratio * shot_distance_max_to_finish / v, time_ratio * shot_distance_max_to_finish / v, 0);
					self.block waittill("movedone");
				}
			}
			else if(int(abs(c) + 0.1) > 0)
			{
				if (time_ratio * shot_distance_max_to_finish / v > 0)
				{
					self.block moveto(self.block.origin + (0, 0, c), time_ratio * shot_distance_max_to_finish / v, time_ratio * shot_distance_max_to_finish / v, 0);
					self.block waittill("movedone");
				}
			}
			self.moving = false;
		}
		wait (0.1);
		self.shot = false;
		wait (0.1);
	}
}


abs(number)
{
	if (number < 0)
	{
		number = -1 * number;
	}
	return number;	
}

sqrt(number)
{
	g = number;
	if (g > 0)
	{
		g = number / 10;
		for(i=0;i<10;i++)
		{
			g = (number + g * g) / (2 * g);
		}
	}
	return g;
}

get_percent_clip(numerator, denominator)
{
	p = int(numerator / denominator * 100);
	if (p > 100)
	{
		p = 100;
	}
	else if (p < -100)
	{
		p = -100;
	}
	return p;
}

get_angle_difference(angle1, angle2)
{
	a = angle1 - angle2;
	if (a > 180)
	{
		a = a - 360;
	}
	if (a < -180)
	{
		a = a + 360;
	}
	return a;
}

get_pos_angle(angle)
{
	a = angle;
	if (a < 0)
	{
		a = a + 360;
	}
	else if (a > 360)
	{
		a = a - 360;
	}
	return a;
}

get_x(v)
{
	h = 64;
	x1 = (-1 * h, 0, 0);
	x2 = (h, 0, 0);
	r1 = distance(x1, v);
	r2 = distance(x2, v);
	x = (r1 * r1 - r2 * r2) / (4 * h);
	return x;
}

get_y(v)
{
	h = 64;
	y1 = (0, -1 * h, 0);
	y2 = (0, h, 0);
	r1 = distance(y1, v);
	r2 = distance(y2, v);
	y = (r1 * r1 - r2 * r2) / (4 * h);
	return y;
}

get_z(v)
{
	h = 64;
	z1 = (0, 0, -1 * h);
	z2 = (0, 0, h);
	r1 = distance(z1, v);
	r2 = distance(z2, v);
	z = (r1 * r1 - r2 * r2) / (4 * h);
	return z;
}

player_block_tower_collision(player, tower)
{
	player_half_width = level.player_width / 2;
	tower_half_width = level.block_tower_width / 2;
	tower_half_height = level.block_tower_height / 2;
	if ((get_x(player.origin) + player_half_width > get_x(tower.origin) - tower_half_width) && (get_x(player.origin) - player_half_width < get_x(tower.origin) + tower_half_width) && (get_y(player.origin) + player_half_width > get_y(tower.origin) - tower_half_width) && (get_y(player.origin) - player_half_width < get_y(tower.origin) + tower_half_width) && (get_z(player.origin) + level.player_height > get_z(tower.origin) - tower_half_height) && (get_z(player.origin) < get_z(tower.origin) + tower_half_height))
	{
		return true;
	}
	else
	{
		return false;
	}
}

player_block_letter_collision(player, block)
{
	player_half_width = level.player_width / 2;
	if ((get_x(player.origin) + player_half_width > get_x(block.starting_origin) - block.radius) && (get_x(player.origin) - player_half_width < get_x(block.starting_origin) + block.radius) && (get_y(player.origin) + player_half_width > get_y(block.starting_origin) - block.radius) && (get_y(player.origin) - player_half_width < get_y(block.starting_origin) + block.radius) && (get_z(player.origin) + level.player_height > get_z(block.starting_origin) - block.radius) && (get_z(player.origin) < get_z(block.starting_origin) + block.radius))
	{
		return true;
	}
	else
	{
		return false;
	}
}